/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004-2007 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

template<typename DI>
DataSelectorInputList<DI>:: DataSelectorInputList(Db::Database *database,
						  const String &table,
						  const StringList &selection_columns,
						  Gtk::Window *parent,
						  const String &title)
  : DataSelectorList (database,
		      table,
		      selection_columns,
		      title),
     _parent(parent)
{
  //
  // Control buttons
  //
  Gtk::VButtonBox * buttons = Gtk::manage(new Gtk::VButtonBox(Gtk::BUTTONBOX_START));
  get_box().pack_start(*buttons, false, true);
  
  Gtk::Button * button = Gtk::manage(new Gtk::Button(Gtk::Stock::ADD));
  button->set_focus_on_click(false);
  button->signal_clicked().connect( sigc::mem_fun(*this, &DataSelectorInputList<DI>::input) );
  buttons->pack_start(*button, true, true); 
}

template<typename DI>
void
DataSelectorInputList<DI>:: input()
{
  DataInput * di = new DI(*_parent);
  
  Db::PStatementPtr stmt(get_database()->
			 get_table_insert_statement(String(get_table_name()),
						    di->get_insert_columns()));
  
  bool values_gotten( di->get_values(*stmt) );
  if (!values_gotten)
    return;
  
  stmt->execute();

  refresh();
}

template<typename DI>
void
DataSelectorInputList<DI>:: refreshed()
{
  
}
