/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <iostream>

#include <stdlib.h>

#include "libtkcommon/exceptions.h"
#include "libtkcommon/debug.h"
#include "libtkcommon/real_time.h"
#include "retriever.h"

using namespace TkResolver;
using namespace Random;

Retriever:: Retriever(unsigned count)
  : _count(count),
    _thread(0),
    _buffer(0)
{
  if(!Glib::thread_supported())
    Glib::thread_init();
}

void
Retriever:: start()
{
  _thread = Glib::Thread::create(sigc::mem_fun(*this, &Retriever::run), true);
}

void
Retriever:: run()
{
  thread_set_real_time(40);
  
  _buffer = retrieve();
}

Buffer *
Retriever:: join()
{
  _thread->join();
  return _buffer;
}


unsigned &
Retriever:: get_count()
{
  return _count;
}

